package com.example.grademanager_gui;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.ButtonType;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

import java.io.IOException;
import java.util.Optional;

import static com.example.grademanager_gui.MainController.*;

public class CourseModificationController {
    @FXML
    protected ComboBox<String> bachelorSemesterComboBox;
    @FXML
    protected ComboBox<String> courseTypeComboBox;
    @FXML
    protected ComboBox<String> examTypeComboBox;
    ObservableList<String> bachelorSemesterList = FXCollections.observableArrayList("1", "2", "3", "4", "5", "6", "7", "8",
                                                                                    "9");
    ObservableList<String> courseTypeList = FXCollections.observableArrayList("Pflichtveranstaltung", "AWP", "FWP",
                                                                                        "PLV");
    ObservableList<String> examTypeList = FXCollections.observableArrayList("schriftlich", "mündlich", "Teilnahme");

    @FXML
    protected void initialize() {
        setComboBox(bachelorSemesterComboBox, bachelorSemesterList);
        setComboBox(courseTypeComboBox, courseTypeList);
        setComboBox(examTypeComboBox, examTypeList);
    }


    @FXML
    protected TextField name;
    @FXML
    protected String bachelorSemester;
    @FXML
    protected String courseType;
    @FXML
    protected TextField sws;
    @FXML
    protected TextField ects;
    @FXML
    protected String examType;
    @FXML
    protected TextField warning;


    @FXML
    protected void onSaveButtonClick(ActionEvent event) throws IOException {
        if(!name.getText().isBlank() && bachelorSemesterComboBox.getValue() != null &&
                courseTypeComboBox.getValue() != null && !sws.getText().isBlank() && !ects.getText().isBlank() &&
                examTypeComboBox.getValue() != null)
        {
            bachelorSemester = bachelorSemesterComboBox.getValue();
            courseType = courseTypeComboBox.getValue();
            examType = examTypeComboBox.getValue();

            degreeList.add(name.getText());
            switchToDegreeModification(event);
        }
        else
        {
            warning.setText("Bitte alle Felder ausfüllen.");
            Alert alert = new Alert(Alert.AlertType.ERROR);
            alert.setTitle("Fehler");
            alert.setHeaderText("Bitte alle Felder ausfüllen.");
            Optional<ButtonType> result = alert.showAndWait();
        }
    }


    private Stage stage;
    private Scene scene;
    private FXMLLoader root;

    @FXML
    protected void switchToDegreeModification(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("degree-modification.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Degree Modification");
        stage.setScene(scene);
        stage.show();
    }
}
