package com.example.grademanager_gui;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.ComboBox;

import javafx.scene.*;
import javafx.scene.Node;
import javafx.stage.*;

import java.io.IOException;
import java.util.ArrayList;

public class MainController {
    @FXML
    protected ComboBox<String> degreeComboBox;
    @FXML
    protected ComboBox<String> studentComboBox;
    static public ObservableList<String> degreeList = FXCollections.observableArrayList();
    static public ObservableList<String> studentList = FXCollections.observableArrayList();

    static public void setComboBox(ComboBox<String> comboBox, ObservableList<String> list) {
        comboBox.setItems(list);
    }

    @FXML
    protected void initialize() {
        if(!degreeList.isEmpty())
        {
            setComboBox(degreeComboBox, degreeList);
        }
        if(!studentList.isEmpty())
        {
            setComboBox(studentComboBox, studentList);
        }
    }


    private Stage stage;
    private Scene scene;
    private FXMLLoader root;

    @FXML
    protected void switchToMain(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("main.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Main");
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    protected void switchToStudentDetails(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("student-details.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Student Details");
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    protected void switchToStudentModification(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("student-modification.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Student Modification");
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    protected void switchToDegreeDetails(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("degree-details.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Degree Details");
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    protected void switchToDegreeModification(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("degree-modification.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Degree Modification");
        stage.setScene(scene);
        stage.show();
    }
}
